package org.antlr.codegen;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import org.antlr.Tool;
import org.antlr.codegen.CodeGenerator;
import org.antlr.codegen.Target;
import org.antlr.tool.Grammar;
import org.stringtemplate.v4.AttributeRenderer;
import org.stringtemplate.v4.ST;
import org.stringtemplate.v4.STGroup;

public class RubyTarget extends Target {
  public static final Set<String> rubyKeywords = (Set<String>)new Object();
  
  public static Map<String, Map<String, Object>> sharedActionBlocks = new HashMap<String, Map<String, Object>>();
  
  protected void genRecognizerFile(Tool tool, CodeGenerator generator, Grammar grammar, ST outputFileST) throws IOException {
    if (grammar.type == 4) {
      Map<String, Map<String, Object>> actions = grammar.getActions();
      if (actions.containsKey("all"))
        sharedActionBlocks.put(grammar.name, actions.get("all")); 
    } else if (grammar.implicitLexer && 
      sharedActionBlocks.containsKey(grammar.name)) {
      Map<String, Map<String, Object>> actions = grammar.getActions();
      actions.put("all", sharedActionBlocks.get(grammar.name));
    } 
    STGroup group = generator.getTemplates();
    RubyRenderer renderer = new RubyRenderer(this);
    try {
      group.registerRenderer(Class.forName("java.lang.String"), (AttributeRenderer)renderer);
    } catch (ClassNotFoundException e) {
      System.err.println("ClassNotFoundException: " + e.getMessage());
      e.printStackTrace(System.err);
    } 
    String fileName = generator.getRecognizerFileName(grammar.name, grammar.type);
    generator.write(outputFileST, fileName);
  }
  
  public String getTargetCharLiteralFromANTLRCharLiteral(CodeGenerator generator, String literal) {
    int code_point = 0;
    literal = literal.substring(1, literal.length() - 1);
    if (literal.charAt(0) == '\\') {
      switch (literal.charAt(1)) {
        case '"':
        case '\'':
        case '\\':
          code_point = literal.codePointAt(1);
          return "0x" + Integer.toHexString(code_point);
        case 'n':
          code_point = 10;
          return "0x" + Integer.toHexString(code_point);
        case 'r':
          code_point = 13;
          return "0x" + Integer.toHexString(code_point);
        case 't':
          code_point = 9;
          return "0x" + Integer.toHexString(code_point);
        case 'b':
          code_point = 8;
          return "0x" + Integer.toHexString(code_point);
        case 'f':
          code_point = 12;
          return "0x" + Integer.toHexString(code_point);
        case 'u':
          code_point = Integer.parseInt(literal.substring(2), 16);
          return "0x" + Integer.toHexString(code_point);
      } 
      System.out.println("1: hey you didn't account for this: \"" + literal + "\"");
    } else if (literal.length() == 1) {
      code_point = literal.codePointAt(0);
    } else {
      System.out.println("2: hey you didn't account for this: \"" + literal + "\"");
    } 
    return "0x" + Integer.toHexString(code_point);
  }
  
  public int getMaxCharValue(CodeGenerator generator) {
    return 255;
  }
  
  public String getTokenTypeAsTargetLabel(CodeGenerator generator, int ttype) {
    String name = generator.grammar.getTokenDisplayName(ttype);
    if (name.charAt(0) == '\'')
      return generator.grammar.computeTokenNameFromLiteral(ttype, name); 
    return name;
  }
  
  public boolean isValidActionScope(int grammarType, String scope) {
    if (scope.equals("all"))
      return true; 
    if (scope.equals("token"))
      return true; 
    if (scope.equals("module"))
      return true; 
    if (scope.equals("overrides"))
      return true; 
    switch (grammarType) {
      case 1:
        if (scope.equals("lexer"))
          return true; 
        break;
      case 2:
        if (scope.equals("parser"))
          return true; 
        break;
      case 4:
        if (scope.equals("parser"))
          return true; 
        if (scope.equals("lexer"))
          return true; 
        break;
      case 3:
        if (scope.equals("treeparser"))
          return true; 
        break;
    } 
    return false;
  }
  
  public String encodeIntAsCharEscape(int v) {
    int intValue;
    if (v == 65535) {
      intValue = -1;
    } else {
      intValue = v;
    } 
    return String.valueOf(intValue);
  }
}
